//Single JJ-time dependence of voltage, phase difference and CVC 29-01-2013
//Один ДП -временная зависимость напряжении, разности фаз и ВАХ 29-01-2013
#include<iostream>
#include<cmath>
#include<cstdio>

int main()
	{
	using namespace std;
	int
		t,	//index of time
			//индекс по времени
		ti,	//number of time cycles from which of we begin integration
			//номер цикла по времени с которого начнается интегрирование
		a=1,//parameter for direction of current
			//параметр для определения направлении тока
		tN,	//total number of time cycles
			//количество точек (циклов) по времени
		ICounter,
		pt=0,	//parameter to check recording of time dependence
				//параметр для проверки записи временной зависимости
		breakcurrant=0,
		backcurrent=0,

		at=-1;	//in up or down for time dependence put 1 or -1
				//в случае возростания или убываения тока для
				//временной зависимости соответсвенно вставте 1 или -1
	//######################################################################################
	double
		Ti=50,	//Initial value of time averaging
				//Начальная значения времени усреднения
		Tf0=200,//Time domain for one step of current
				//Временной домен для одного шага тока
		Tf1=200,//Time domain for one step of current in time dependence procedure 
				//Временной домен для одного шага тока при вычислении временной зависимости
		TP=0.0125,//Step of time
				//Шаг по времени
		JP0=0.005,	//Step of current outside current interval [Imore1,Imore2]
					//Шаг по току вне интервала [Imore1,Imore2]
		JP1=0.005,	//Step of current inside current interval [Imore1,Imore2]
					//Шаг по току в интервале [Imore1,Imore2]
		Imore1=-1,
		Imore2=1,
		I0=0.1,	//Initial value of bias current
				//Начальное значения тока 
		Imax=2.5,	//Maximal value of bias current
				//Максимальное значения тока
		Imin=-2.5,//Минимальное значения тока
		Ibreak=0,//Ток при которой вычисление останавливается

		Omega=0,//Частота внешнего излучения
		Amp=0,//Амплитуда внешнего излучения
	
		beta=2,	//Dissipation parameter
					//Параметр диссипации
		Itime1=0.8,//Minimal current value for time dependence recording
					//Минамальное значения тока для записи временной зависимости
		Itime2=0.8,//Maximal current value for time dependence recording
					//Максимальное значения тока для записи временной зависимости
		v,	// voltage
			// напряжение
		intV,	//Variable for voltage integration
			//Переменный для интегрирования напряжении
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Runge-Kutta coefficients
		//Коэффициенты Рунге-Кутта
		P1,P2,P3,P4,
		V1,V2,V3,V4,
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		V,	//Variable for Voltage at fixed time
			//Переменный для напряжение в фиксированном времени
		ph,	//Variable for phase differences at fixed time
			//Переменный для разности фаз в фиксированном времени
		time=0,	//Time for recording
			//Время для записи
		I,	//Bias current
			//Входной ток
		Tf=Tf0,JP=JP0;
//#######################################################################################
	//Creation result's files
	//Создания файлов для результатов
	FILE *f,*f5,*f6;
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//file for CVC
	//файл для ВАХ
	f=fopen("Voltage.dat","w");	
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//file for Voltage-time dependence
	//файл для временной зависимости напряжении
	f5=fopen("V(time).dat","w");	
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//file for phase difference-time dependence
	//файл для временной зависимости разность фаз
	f6=fopen("ph(time).dat","w");
	//*****************************************************************
	tN=(Tf/TP);
	ti=tN*Ti/Tf;
	//***************************************	
	//Calculation of initial condition
	//Вычисления начальных условий
	ph=0;
	intV=0;
	V=0;
	//*****************************************
	ICounter=0;
	v=0;
	I=I0;
//#######################################################################
	do{	// Here the cycle of current begins
		//Здесь начинается цикл по току
		t=0;
		do{	//Here the cycle of time begins
			//Здесь начинается цикл по времени
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Starting of Runge-Kutta method
	//Начало метода Рунге-Кутта
			//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
			//The first coefficients of Runge-Kutta method
			//Первые коэффициенты метода Рунге-Кутта
			V1=TP*(I+Amp*sin(Omega*(t*TP+ICounter*tN*TP))
				-sin(ph)-beta*V);
			P1=TP*V;
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//The second coefficients of Runge-Kutta method
			//Вторые коэффициенты метода Рунге-Кутта
			V2=TP*(I+Amp*sin(Omega*(TP*t+TP/2+ICounter*tN*TP))
				-sin(ph+P1/2)-beta*(V+V1/2));
			P2=TP*(V+V1/2);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//The third coefficients of Runge-Kutta method
			//Третые коэффициенты метода Рунге-Кутта
			V3=TP*(I+Amp*sin(Omega*(TP*t+TP/2+ICounter*tN*TP))
				-sin(ph+P2/2)-beta*(V+V2/2));
			P3=TP*(V+V2/2);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			//The fourth coefficients of Runge-Kutta method
			//Четвертые коэффициенты метода Рунге-Кутта
			V4=TP*(I+Amp*sin(Omega*(TP*t+TP+ICounter*tN*TP))
				-sin(ph+P3)-beta*(V+V3));
			P4=TP*(V+V3);
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			ph=ph+(P1+2*P2+2*P3+P4)/6;
		 	V=V+(V1+2*V2+2*V3+V4)/6;
			if (t>ti)intV=V*TP+intV;
	//Ending of Runge-Kutta method
	//Конец метода Рунге-Кутта
	//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
		// Starting of time dependence calculation
		// Начало вычисления временных зависимостей
			if((I<(Itime2+JP1/2))&&(I>(Itime1-JP1/2))&&(a==at))
				{pt=1;tN=Tf1/TP;Tf=Tf1;
				//Recording time Formula
				//Формула записываемого времени
				if(at==-1){time=t*TP-(TP*tN*(Itime2-I)*at)/JP;}
				if(at==1){time=t*TP+(TP*tN*(I-Itime1)*at)/JP;}
				//**************************************
				//Time recording
				//Запись времени		
				fprintf(f5,"%f\t",time);
				fprintf(f6,"%f\t",time);
				//**************************************
				//Here phase difference will be recorded
				//Здесь записывается разность фаз
				fprintf(f6,"%e\t",ph);
				//*************************************************
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				//Here will be recorded voltage
				//Здесь записывается напряжение 
				fprintf(f5,"%e\t",V);
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				//Here will be recorded bias current
				//Здесь записывается входной ток
				fprintf(f5,"%f\t",I);
				fprintf(f6,"%f\t",I);
				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				//Going to new line
				//Переход на новую строку
				fprintf(f5,"\n");
				fprintf(f6,"\n");
			}else{tN=Tf0/TP;Tf=Tf0;};
	// Ending of time dependence calculation
	//Конец вычисления временных зависимостей
	//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		//Here the cycle of time finishs
		//Здесь цикл по времени закончивается
		}while(++t<tN+1);
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Voltage averaging
		//Усреднение напряжения
		v=intV/(Tf-Ti);
		intV=0;
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//showing results on the screen
		//вывод результатов на экран
		cout<<"\n\nI:"<<I<<"\tV:"<<v;
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Here will be recorded bias Current and total voltage
		//Здесь записывается входной ток и суммарное напряжение
		fprintf(f,"%f\t%e\n",I,v);
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Условие для возврата тока
		if ((I<=Imin+JP1/2)&&(backcurrent==0)&&(a==-1)){
		backcurrent=1;
		breakcurrant=1;
		a=1;
		};
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Condition for changing current dirrection
		//Условие для изменения направлении тока
		if (I>Imax){	
			cout<<"here is max of current so we  go back"<<endl;
			a=-1;};
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		ICounter=ICounter+1;
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Here bias current will be changed
		//Здесь изменяется направление тока
		I=I+a*JP;
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		if((backcurrent==1)&&(I>=Ibreak-JP1/2)&&(a==1))
			{
				break;
			};
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//Condition for chenging step of current
		//Условие для изменения шага по току
		if ((I<=Imore2+JP1/2)&&(I>=Imore1-JP1/2)){JP=JP1;tN=Tf1/TP;Tf=Tf1;}else{JP=JP0;tN=Tf0/TP;Tf=Tf0;};
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//Here cycle of current finishs
	//Здесь закончивается цикл по току
	}while(I<=100);
	//**********************
	// Here all files will be closed
	//Здесь все файлы закрываются
	fclose(f);
	fclose(f5);
	fclose(f6);
return(0);
}
